do
--local VeterancyHelper = import('/mods/TotalVeterancy/helper/VeterancyHelper.lua')
    local oldModBP = ModBlueprints

    function ModBlueprints(all_bps)
        oldModBP(all_bps)

        --parameters for customisation
        local scalling = (1/2)
        local evenkills = 4

        --base values calculated from cost to compare
        --t1(Mantis)=64  t2(Rhino)= 238 t3(Loyalist)=603 Monkeylord=17480
        local ACUbaseValue = 750
        local SCUbaseValue = 1100  --11k if calculated by cost

        --dropdown code for lobby not working
       
        --g-it may work with a support scd file or a map which sets the option
        --not sure if former will play nice in mp games
        
        --if ScenarioInfo.Options.XPFormular == "3/4" then
        --    LOG('is set')
        --else
        --    LOG('not set')
        --end

        local once = true
        for id,bp in all_bps.Unit do
            if bp.Defense.RegenRate == nil then
                bp.Defense.RegenRate = 0
            end
            local RegenMod = 0.9*(50 - 1 / (0.00000060257 * bp.Defense.MaxHealth + 0.020016))
            bp.Defense.RegenRate = bp.Defense.RegenRate + RegenMod

            -- Override for ACUs and SCUs
            if bp.Economy and not bp.Economy.xpBaseValue and bp.Economy.BuildCostMass and bp.Economy.BuildCostEnergy and bp.Economy.BuildTime and table.find(bp.Categories,'COMMAND') then
                bp.Economy.xpBaseValue = ACUbaseValue
            end
            if bp.Economy and not bp.Economy.xpBaseValue and bp.Economy.BuildCostMass and bp.Economy.BuildCostEnergy and bp.Economy.BuildTime and table.find(bp.Categories,'SUBCOMMANDER') then
                bp.Economy.xpBaseValue = SCUbaseValue
            end

            --calculate xp depending on xpBaseValue of from cost if no base value is set.
            --old values are not overwriten
            if bp.Economy and not bp.Economy.xpValue and bp.Economy.BuildCostMass and bp.Economy.BuildCostEnergy and bp.Economy.BuildTime and (not table.find(bp.Categories,'UNTARGETABLE') or bp.Economy.xpBaseValue) then
                bp.Economy.xpValue = math.pow((bp.Economy.xpBaseValue or (bp.Economy.BuildCostMass + bp.Economy.BuildCostEnergy/200 + bp.Economy.BuildTime/25)),scalling)
                --if bp.Description then LOG(bp.Description .. ' ' .. bp.Economy.xpValue) end
            end

            --calculate xp per level dependind on own value and kills per level set.
            if bp.Economy and not bp.Economy.XPperLevel and bp.Economy.xpValue then
                bp.Economy.XPperLevel = bp.Economy.xpValue * evenkills
            end
            if bp.Economy and bp.Defense and not bp.Economy.xpPerHp and bp.Economy.xpValue and bp.Defense.MaxHealth then
                bp.Economy.xpPerHp = bp.Economy.xpValue / bp.Defense.MaxHealth
            end
            
            --AutoXP merge
          
            --structures which generate resources gain AutoXP
            --moved PowerplantXP
            if bp.Categories and table.find(bp.Categories,'STRUCTURE') and (table.find(bp.Categories,'MASSEXTRACTION') or table.find(bp.Categories,'ENERGYPRODUCTION') or table.find(bp.Categories,'MASSFABRICATION') or table.find(bp.Categories,'MASSPRODUCTION')) and not bp.Economy.xpTimeStep and not table.find(bp.Categories,'UNTARGETABLE') then
                bp.Economy.xpTimeStep = math.random(580,620)--math.random for load balancing
            end
            -- Intel gains xp
            if bp.Categories and table.find(bp.Categories,'INTELLIGENCE') and (table.find(bp.Categories,'STRUCTURE') or table.find(bp.Categories,'MOBILESONAR')) and not bp.Economy.xpTimeStep and not table.find(bp.Categories,'UNTARGETABLE') then --spread the load to avoid tons of stuff upgrading
                bp.Economy.xpTimeStep = math.random(290,310) -- at the same time
            end
            -- Immobile Shields gain xp
            if bp.Categories and table.find(bp.Categories,'STRUCTURE') and table.find(bp.Categories,'SHIELD') and not bp.Economy.xpTimeStep  and not table.find(bp.Categories,'UNTARGETABLE') then 
                bp.Economy.xpTimeStep = math.random(650,670) 
            end --spread the load to avoid tons of stuff upgrading at the same time
            
            --BuildXP
            if bp.Categories and (table.find(bp.Categories,'CONSTRUCTION') or table.find(bp.Categories,'ENGINEER') or table.find(bp.Categories,'FACTORY') ) and not table.find(bp.Categories,'UNTARGETABLE') and not bp.Economy.BuildxpLevelpSecond then
                bp.Economy.BuildXPLevelpSecond = 1/(math.random(350,370))
            end
        end
    end
end
